//---------------------------------------------------------------------------

#include "bitmask.h"
//---------------------------------------------------------------------------

/* 
   @author Korniloff E.
     2007
*/




int firstBit[0xff+1];
int lastBit[0xff+1];
const U64  null64 = 0x0000000000000000;
U64  pawnPromoteMask[2][64],pawnBackMask[2][64],knightAttack[64],kingAttack[64];
U64 openLine[2][64];
const U64 rank6[2] = {0x00ff000000000000, 0x000000000000ff00};
U64 kingSquare[64];
U64 a1h8Diag[64];
U64 a8h1Diag[64];
U64 blackSq, whiteSq;
const U64 upBoard[2][8] = {//0xffffffffffffffff
{
  0x0000000000000000,
  0x00000000000000ff,
  0x000000000000ffff,
  0x0000000000ffffff,
  0x00000000ffffffff,
  0x000000ffffffffff,
  0x0000ffffffffffff,
  0x00ffffffffffffff       
},
{
  0xffffffffffffff00,
  0xffffffffffff0000,
  0xffffffffff000000,
  0xffffffff00000000,
  0xffffff0000000000,
  0xffff000000000000,
  0xff00000000000000,
  0x0000000000000000
}
};
//  1.2.3   ( )
int SqOnA1H8Diag(int sq,int c ){
  const int white_mask[64] =
  {
    0,0,0,0,0,0,2,3,
    0,0,0,0,0,2,3,1,
    0,0,0,0,2,3,1,0,
    0,0,0,2,3,1,0,0,
    0,0,2,3,1,0,0,0,
    0,2,3,1,0,0,0,0,
    2,3,1,0,0,0,0,0,
    3,1,0,0,0,0,0,0
  };
  const int black_mask[64] =
  {
    0,0,0,0,0,0,1,3,
    0,0,0,0,0,1,3,2,
    0,0,0,0,1,3,2,0,
    0,0,0,1,3,2,0,0,
    0,0,1,3,2,0,0,0,
    0,1,3,2,0,0,0,0,
    1,3,2,0,0,0,0,0,
    3,2,0,0,0,0,0,0
  };
  if( c == WHITE ) return white_mask[sq];
  return black_mask[sq];
}

int SqOnA8H1Diag(int sq,int c ){
  const int white_mask[64] =
  {
    3,2,0,0,0,0,0,0,
    1,3,2,0,0,0,0,0,
    0,1,3,2,0,0,0,0,
    0,0,1,3,2,0,0,0,
    0,0,0,1,3,2,0,0,
    0,0,0,0,1,3,2,0,
    0,0,0,0,0,1,3,2,
    0,0,0,0,0,0,1,3,
  };
  const int black_mask[64] =
  {
    3,1,0,0,0,0,0,0,
    2,3,1,0,0,0,0,0,
    0,2,3,1,0,0,0,0,
    0,0,2,3,1,0,0,0,
    0,0,0,2,3,1,0,0,
    0,0,0,0,2,3,1,0,
    0,0,0,0,0,2,3,1,
    0,0,0,0,0,0,2,3,
  };
  if( c == WHITE ) return white_mask[sq];
  return black_mask[sq];
}


/*
        k ()
   ,   

        
*/
/*
int OpenDiag( int isA1H8,  int sq, int c )
{
  U64 m;
  if( c == WHITE )
  {
    if( isA1H8 )
      m = a1h8Diag[sq] &  upBoard[WHITE][ROW(sq)];
    else
      m = a8h1Diag[sq] &  upBoard[WHITE][ROW(sq)];

    return  (m & WHITE_PAWNS) == 0  &&
            SavePawns( m & BLACK_PAWNS, BLACK_PAWNS, BLACK ) == 0;
  }else{
    if( isA1H8 )
      m = a1h8Diag[sq] &  upBoard[BLACK][ROW(sq)];
    else
      m = a8h1Diag[sq] &  upBoard[BLACK][ROW(sq)];
    return  (m & BLACK_PAWNS) == 0  &&
            SavePawns( m & WHITE_PAWNS, WHITE_PAWNS, WHITE ) == 0;
  }
  //return  (m & ALL_PAWNS) == 0;
}
*/

int OpenDiagA1H8( int sq, int c )
{
  U64 m;
  if( c == WHITE )
  {
      m = a1h8Diag[sq] &  upBoard[WHITE][ROW(sq)];
  }else{
      m = a1h8Diag[sq] &  upBoard[BLACK][ROW(sq)];
  }
  return  (m & ALL_PAWNS) == 0;
}

int OpenDiagA8H1( int sq, int c )
{
  U64 m;
  if( c == WHITE )
  {
      m = a8h1Diag[sq] &  upBoard[WHITE][ROW(sq)];
  }else{
      m = a8h1Diag[sq] &  upBoard[BLACK][ROW(sq)];
  }
  return  (m & ALL_PAWNS) == 0;
}




/*
      ( )
*/
U64 SavePawns( U64 currPawns, U64 allPawns, int c )
{
 U64 PawnAtkMask( U64 pawns, int c );

 return currPawns & PawnAtkMask( allPawns, c );
}


int HasWhiteBishop(int c){
  if(c == WHITE)
    return ( whiteSq & g.pieces[BISHOP] & g.all[WHITE] ) != 0;
  else
    return ( whiteSq & g.pieces[BISHOP] & g.all[BLACK] ) != 0;
}

int HasBlackBishop(int c){
  if(c == WHITE)
    return ( blackSq & g.pieces[BISHOP] & g.all[WHITE] ) != 0;
  else
    return ( blackSq & g.pieces[BISHOP] & g.all[BLACK] ) != 0;
}

/*
    -     
*/
int BadA1H8(int c){
  if(c == WHITE){
     return    SavePawns(  WHITE_PAWNS & a1h8Diag[A1],
                           WHITE_PAWNS,
                           WHITE ) == 0;
  }else{
     return    SavePawns(  BLACK_PAWNS & a1h8Diag[A1],
                           BLACK_PAWNS,
                           BLACK ) == 0;
  }
}

/*
      
        
              
        -  
     ->     
*/
int KingAroundBadMainDiag(int c){
  if(c == WHITE){
    if( (a1h8Diag[A1] & WHITE_PAWNS) == 0 &&
        (kingAttack[ g.kingSq[WHITE] ]   &  a1h8Diag[A1])  &&
         HasBlackBishop(BLACK)  &&
        (a1h8Diag[A1] & g.pieces[BISHOP] & g.all[WHITE]) == 0
      )
        return 1;
    if( (a8h1Diag[A1] & WHITE_PAWNS) == 0 &&
        (kingAttack[ g.kingSq[WHITE] ]   &  a8h1Diag[A8])  &&
         HasWhiteBishop(BLACK)  &&
        (a8h1Diag[A8] & g.pieces[BISHOP] & g.all[WHITE]) == 0
        ) return 1;
  }else{
    if( (a1h8Diag[A1] & BLACK_PAWNS) == 0 &&
        (kingAttack[ g.kingSq[BLACK] ]   &  a1h8Diag[A1])  &&
        HasBlackBishop(WHITE)  &&
        (a1h8Diag[A1] & g.pieces[BISHOP] & g.all[BLACK]) == 0
      ) return 1;
    if( (a8h1Diag[A1] & BLACK_PAWNS) == 0 &&
        (kingAttack[ g.kingSq[BLACK] ]   &  a8h1Diag[A8])  &&
         HasWhiteBishop(WHITE)  &&
        (a8h1Diag[A8] & g.pieces[BISHOP] & g.all[BLACK]) == 0 
      ) return 1;
  }
  return 0;
}

int BadA8H1(int c){
  if(c == WHITE){
     return    SavePawns(  WHITE_PAWNS & a8h1Diag[A8],
                           WHITE_PAWNS,
                           WHITE ) == 0;
  }else{
     return    SavePawns(  BLACK_PAWNS & a8h1Diag[A8],
                           BLACK_PAWNS,
                           BLACK ) == 0;
  }
}


int HasPawn7Rank(int c){
  if(c==WHITE)
    return  (rank6[WHITE] & WHITE_PAWNS) != 0;
  else
    return  (rank6[BLACK] & BLACK_PAWNS) != 0;

}

/*
       
        
      ,
       .
      
     
     7  ()
*/
int OpenLine(int c, int sq){

   if(c==WHITE){
     return (openLine[WHITE][sq] &  WHITE_PAWNS) == 0;
   }else{
    return (openLine[BLACK][sq] &  BLACK_PAWNS) == 0;
   }
}

int RookAccompaniesPassedPawn(int c, int passed_pawn_sq){
   int sq = passed_pawn_sq;

   if(c==WHITE){
     return
       (openLine[BLACK][sq] &  g.pieces[ROOK] & g.all[WHITE]) != 0;
   }else{
    return
      (openLine[WHITE][sq] &  g.pieces[ROOK] & g.all[BLACK]) != 0;
   }
}

/*
       
*/
int OperatingLine( int sq ){

  return (openLine[BLACK][COLUMN(sq)] & ALL_PAWNS) == 0;
}


U64 ArrayToMask( const int v[64] )
{
  U64 m = 0;
  int j;
  
  for(j = 0; j < 64; j++)
   if(v[j]){
      SET64( m, j );
   }
   
  return m; 
}

void MaskToArray( U64 m, int v[8][8] ){

 int j;
    for(j = 0; j < 64; j++)
      if(m & ((U64)1<<j))
         v[ROW(j)][COLUMN(j)] = 1;
      else
          v[ROW(j)][COLUMN(j)] = 0;

}


//const f = 0xFFFFFFFF FFFFFFFF
/*
 
extern __inline int GetFirst(U64 m){
	
	_asm{
       MOV EAX,DWORD PTR m
	   TEST EAX,EAX
	   JZ M1
       BSF EAX,EAX
	   jmp M2
M1:
	   MOV EAX, DWORD PTR (m+4)
	   BSF EAX,EAX
	   ADD EAX,32
M2:

	}
	
	
_asm { mov  eax, dword ptr m[0]
         test eax, eax
         jz   f_hi
         bsf  eax, eax
         jmp  f_ret
f_hi:    bsf  eax, dword ptr m[4]
         add  eax, 20h
f_ret:
  }
	  

}
   */
	
int GetFirst(U64 m){

  if( m & 0xFFFFFFFF ){
     if(m & 0xFFFF){
        if(m & 0xFF){
           return  firstBit[ (unsigned)m & 0xFF ];
        }else{
           return  firstBit[ ((unsigned)m >> 8) & 0xFF ] + 8;
        }
     }else{
        if(m & 0xFF0000){
           return  firstBit[ ((unsigned)m >> 16) & 0xFF ] + 16;
        }else{
           return  firstBit[ ((unsigned)m >> 24) & 0xFF ] + 24;
        }
     }
  }else{
    m >>= 32;
     if(m & 0xFFFF){
        if(m & 0xFF){
           return  firstBit[ (unsigned)m & 0xFF ] + 32;
        }else{
           return  firstBit[ ((unsigned)m >> 8) & 0xFF ] + 8 + 32;
        }
     }else{
        if(m & 0xFF0000){
           return  firstBit[ ((unsigned)m >> 16) & 0xFF ] + 16 + 32;
        }else{
           return  firstBit[ ((unsigned)m >> 24) & 0xFF ] + 24 + 32;
        }
     }
  }
}


//  ,   
U64 CapPawnMask( int c ){
  #define L_MASK ~0x0101010101010101
  #define R_MASK ~0x8080808080808080
  U64 m;
  if(c == WHITE){
     m =  (((g.all[BLACK] << 9) & L_MASK) & g.pawnMask[WHITE])  |
          (((g.all[BLACK] << 7) & R_MASK) & g.pawnMask[WHITE]);
  }else{
     m =  (((g.all[WHITE] >> 9) & R_MASK) & g.pawnMask[BLACK])  |
          (((g.all[WHITE] >> 7) & L_MASK) & g.pawnMask[BLACK]);

  }
  return m;
}

//   
U64 PawnAtkMask( U64 pawns, int c ){
  if(c == WHITE){
     return  ((pawns >> 9) & R_MASK) | ((pawns >> 7) & L_MASK);
  }else{
     return  ((pawns << 9) & L_MASK) | ((pawns << 7) & R_MASK);
  }
}



// ,     ( )
U64 PromotePawnMask(int c){
  U64 empty = ~(g.all[WHITE] | g.all[BLACK]);

  if( c == WHITE )
  {
      return ( (empty & (U64)0xFF) << 8 )  &  g.pawnMask[WHITE];

  }else{
      return ( (empty & (U64)0xFF00000000000000 ) >> 8 )  &  g.pawnMask[BLACK];

  }
}


///////////    INIT VAR. ///////////////////
void SetUpLine( int sq, int c, U64 *mask )
{
   if(c == WHITE){
      while( (unsigned)sq < 64 ){
         SET64( (*mask), sq );
         sq -= 8;
      }
   }else{
      while( (unsigned)sq < 64 ){
         SET64( (*mask), sq );
         sq += 8;
      }
   }
}


void InitBitMask(void){
  int sq;

   //promote
   //white
   // * * *
   //   p
   for(sq = 0; sq < 64; sq++){
     if( ROW(sq) > 0 ){
        SetUpLine(sq-8,WHITE, &pawnPromoteMask[WHITE][sq]);
        if( COLUMN(sq) > 0 ) SetUpLine(sq-1-8,WHITE, &pawnPromoteMask[WHITE][sq]);
        if( COLUMN(sq) < 7 ) SetUpLine(sq+1-8,WHITE, &pawnPromoteMask[WHITE][sq]);
     }
   }
   //BLACK
   for(sq = 0; sq < 64; sq++){
     if( ROW(sq) < 7 ){
         SetUpLine(sq+8,BLACK, &pawnPromoteMask[BLACK][sq]);
        if( COLUMN(sq) > 0 ) SetUpLine(sq-1+8,BLACK, &pawnPromoteMask[BLACK][sq]);
        if( COLUMN(sq) < 7 ) SetUpLine(sq+1+8,BLACK, &pawnPromoteMask[BLACK][sq]);
     }
   }

   //backward
   //white
   //     p
   //   *    *
   for(sq = 0; sq < 64; sq++){
     if( COLUMN(sq) > 0 ) SetUpLine(sq-1,BLACK, &pawnBackMask[WHITE][sq]);
     if( COLUMN(sq) < 7 ) SetUpLine(sq+1,BLACK, &pawnBackMask[WHITE][sq]);
   }
   //BLACK
   for(sq = 0; sq < 64; sq++){
     if( COLUMN(sq) > 0 ) SetUpLine(sq-1,WHITE, &pawnBackMask[BLACK][sq]);
     if( COLUMN(sq) < 7 ) SetUpLine(sq+1,WHITE, &pawnBackMask[BLACK][sq]);
   }


   // FIRST & LAST BIT IN BYTE
   do{
      int j;
      for(j = 0; j <= 0xff; j++){
         int n;
         for(n = 0; n < 8; n++)
          if( (1<<n) & j ){
             firstBit[j] = n;
             break;
          }

         for(n = 7; n >= 0; n--)
          if( (1<<n) & j ){
             lastBit[j] = n;
             break;
          }
      }
   }while(0);

   //king & knight attaks mask
   do{
     int n0,sq,j,u,n1;

     for(sq = 0; sq < 64; sq++)
     {
        n0 = MAP( sq );
        for ( j = d_start[KNIGHT]; j <= d_stop[KNIGHT]; j++ )
        {
          n1 = n0 + dir[j];
          if ( ( n1 & 0x88 ) == 0 )
          {
            u = UNMAP( n1 );
            SET64( knightAttack[sq], u );
          }
        }
     }//for

     // KING ATTACK
     for(sq = 0; sq < 64; sq++)
     {
        n0 = MAP( sq );
        for ( j = d_start[KING]; j <= d_stop[KING]; j++ )
        {
          n1 = n0 + dir[j];
          if ( ( n1 & 0x88 ) == 0 )
          {
            u = UNMAP( n1 );
            SET64( kingAttack[sq], u );
          }
        }
     }//for


   }while(0);


   //OPEN LINE
   //        
   do{
     int c, j;
     for(c = WHITE; c <= BLACK; c++){
      int dP = c==WHITE? -8:8;
      for(j = 0; j < 64; j++){
       if( (unsigned)( j + dP) < 64 )
         SetUpLine(  j + dP,   c,   &openLine[c][j] );
      }
     }
   }while(0);

    // KING SQUARE
   do{
     int sq,j,n1,n0,u;
     for(sq = 0; sq < 64; sq++)
     {
        n0 = MAP( sq );
        for ( j = d_start[KING]; j <= d_stop[KING]; j++ )
        {
          n1 = n0 + dir[j];
          if ( ( n1 & 0x88 ) == 0 )
          {
            u = UNMAP( n1 );
            SET64( kingSquare[sq], u );
          }
        }
        SET64( kingSquare[sq], sq );
     }//for

     //DIAGONAL.
     for(sq = 0; sq < 64; sq += 1)
     {
        n0 = MAP( sq );

        ////////////a1h8
        for( n1 = n0 + -15; ( n1 & 0x88 ) == 0; n1 += -15)
        {
            u = UNMAP( n1 );
            SET64( a1h8Diag[sq], u );
        }
        for( n1 = n0 + 15; ( n1 & 0x88 ) == 0; n1 +=  15)
        {
            u = UNMAP( n1 );
            SET64( a1h8Diag[sq], u );
        }
        SET64( a1h8Diag[sq], sq );

        ////////////a8h1
        for( n1 = n0 + -17; ( n1 & 0x88 ) == 0; n1 += -17)
        {
            u = UNMAP( n1 );
            SET64( a8h1Diag[sq], u );
        }
        for( n1 = n0 + 17; ( n1 & 0x88 ) == 0; n1 +=  17)
        {
            u = UNMAP( n1 );
            SET64( a8h1Diag[sq], u );
        }
        SET64( a8h1Diag[sq], sq );
     }//for



   }while(0);
   do{
     const int black[64] =
          {
       0,1,0,1,0,1,0,1,
       1,0,1,0,1,0,1,0,
       0,1,0,1,0,1,0,1,
       1,0,1,0,1,0,1,0,
       0,1,0,1,0,1,0,1,
       1,0,1,0,1,0,1,0,
       0,1,0,1,0,1,0,1,
       1,0,1,0,1,0,1,0
     };

     const int white[64] =
     {
       1,0,1,0,1,0,1,0,
       0,1,0,1,0,1,0,1,
       1,0,1,0,1,0,1,0,
       0,1,0,1,0,1,0,1,
       1,0,1,0,1,0,1,0,
       0,1,0,1,0,1,0,1,
       1,0,1,0,1,0,1,0,
       0,1,0,1,0,1,0,1
     };


   blackSq = ArrayToMask(  black  );

   whiteSq = ArrayToMask(  white  );

   }while(0);


}





////////////// debug section ///////////////
int TestGetFirst(void){

   int j;

   for( j = 0; j <= 0xff; j++)
     if( firstBit[j] != firstBit[ j & -j ] )
        return 0;

   for( j = 0; j < 64; j++ )
     if ( GetFirst( (U64)1 << j ) != j )  return 0;
   for( j = 63; j >= 0; j-- )
     if ( GetFirst( (U64)1 << j ) != j )  return 0;


   return 1;

}


int PawnFriendKing( int c, int king_sq ){
  if(c == WHITE)
    return (kingAttack[king_sq] & WHITE_PAWNS) != 0;
  else
    return (kingAttack[king_sq] & BLACK_PAWNS) != 0;
}
