//---------------------------------------------------------------------------
/* 
   @author Korniloff E.
     2007
*/

#ifndef bitmaskH
#define bitmaskH

#include "chess.h"

#define SET64(m64, sq)    ((m64) |= (U64)1 << (sq))
#define RESET64(m64, sq)    ((m64) &= ~((U64)1 << (sq)))

#define BLACK_PAWNS  (g.pawnMask[BLACK])
#define WHITE_PAWNS  (g.pawnMask[WHITE])
#define ALL_PAWNS    (BLACK_PAWNS | WHITE_PAWNS)


extern U64  pawnPromoteMask[2][64],pawnBackMask[2][64],
            knightAttack[64],kingAttack[64];


void InitBitMask(void);
#define PassedPawn( c,sq )   ((pawnPromoteMask[c][sq]  &  g.pawnMask[(c)^1])==0)
#define BackPawn( c,sq )   ((pawnBackMask[c][sq]  &  g.pawnMask[c])==0)
          
U64 CapPawnMask( int c );
int GetFirst(U64 m);
U64 PromotePawnMask(int c);
int OpenLine(int c, int sq);
int OperatingLine(  int sq);
int HasPawn7Rank(int c);
int SqOnA1H8Diag(int sq,int c ); // return 1,2,3 - 3 - main. diag
int SqOnA8H1Diag(int sq,int c );
int OpenDiagA1H8( int sq, int c );
int OpenDiagA8H1( int sq, int c );
U64 SavePawns( U64 currPawns, U64 allPawns, int c );
int BadA1H8(int c);
int BadA8H1(int c);
U64 PawnAtkMask( U64 pawns, int c );
int HasWhiteBishop(int c);
int HasBlackBishop(int c);
int KingAroundBadMainDiag(int c);
int RookAccompaniesPassedPawn(int c, int passed_pawn_sq);
int PawnFriendKing( int c, int king_sq );

void MaskToArray( U64 m, int v[8][8] );


//---------------------------------------------------------------------------
#endif
