/* 
   @author Korniloff E.
     2007
*/

#include "learn.h"





#define SZ (1<<16)  //   ( )
Node * learn[SZ]; //  (  )
 
void LearnClear(void)
{
  memset(learn,0,sizeof(learn));
}

 
 
 
/*     , 
      */
Node * NewLNode( char * epd )
{
  Node * p = ( Node * ) malloc( sizeof( Node ) + strlen( epd ) );

  p->score = p->depth = 0; p->next = 0;
  p->isFromLib = 1;
  p->learn = 0; // default for lib. move 
  p->key = g.key;
  p->c = g.side;
  p->size = sizeof( Node ) + strlen( epd );
  strcpy( p->epd, epd );
  return p;
}





void InitToken( TokType * p, char * s, char * del )
{
  int j;
  for ( j = 0; j < 256; j++ ) p->hlat[j] = 0;
  for ( ; * del; del++ ) p->hlat[( unsigned char ) ( * del )] = 1;
  p->begin = p->end = s;
  p->end--;
}

char * GetToken( TokType * p )
{

  if ( * p->begin == '\0' )
    return 0;

  for ( p->begin = p->end + 1; p->hlat[( unsigned char ) ( * p->begin )] == 1 && * p->begin != '\0'; p->begin++ );
  for ( p->end = p->begin; p->hlat[( unsigned char ) ( * p->end )] == 0 && * p->end != '\0'; p->end++ );
  * p->end = '\0';

  if ( * p->begin == '\0' )
    return 0;

  return p->begin;
}


/*        */
void ReadLibFile( char * fname )
{
  int GetStr( char * s, int n, FILE * f );
  void InsertNodeLearn( void );
  void InitNewGame( void );
  int StrToMove( char * s, Move * ret_mv );
  FILE * f;

  printf("# load open book file--->  %s ... \n", fname);

  f = fopen( fname, "r" );
  if ( f )
  {
    int fs;
    char s[0xFFFF], * strMv;
    Move mv;
    int lines = 0;
    struct Game_Type save = g, new_game;
    TokType t, new_token;
    InitToken( & t, s, " !?#,;\n" );
    InitNewGame();
    new_game = g;
    new_token = t;

    while ( (fs = GetStr( s, 0xFFFF - 1, f )) != 0 )
    if( fs == 1) // not comment and not empty line
    {
      lines++;
      t = new_token;
      g = new_game;
      while ( ( strMv = GetToken( & t ) ) != NULL )
      {
        if ( StrToMove( strMv, & mv ) && InsertMoveInGame( mv ) )
        {
          InsertCurrPositionToLearn(); // 
        }else
        {
          printf( "# error: line %d, lexem %s\n", lines, strMv );
          break; //error
        }
      }
    }
    fclose( f );
    g = save;
    printf("# .... done \n");
  }else printf("# ... not found  \n");

}


int GetStr( char * s, int n, FILE * f )
{
  while ( fgets( s, n, f ) )
  {
    char * p = s;
    while ( * p == ' ' ) p++;
    if ( * p != '\0' && * p != '#' && * p != '\n' ) return 1; // lexem
    return -1; // comment
  }
  return 0; // end of file
}




/*    */
void InsertCurrPositionToLearn( void )
{
  char epd[256];
  Node* node = SearchCurrPos();

  
  if ( node == 0)
  {
	Node * p;     
    MakeEpd( epd );
    p = NewLNode( epd );
    if(p)
    {
      
      p->next = learn[( int )g.key & ( SZ - 1 )];
      learn[( int )g.key & ( SZ - 1 )] = p;
    }  
  }
}




/*      epd(pen) r1bqkbnr/ppp1pppp/2n5/3p4/3PP3/8/PPP2PPP/RNBQKBNR w KQkq d3 0 3 */

void MakeEpd( char * s )
{
  const char ch_piece[2] [8] =
  {
    {
      0, 'P', 'N', 'B', 'R', 'Q', 'K', 0
    },
    {
      0, 'p', 'n', 'b', 'r', 'q', 'k', 0
    }
  };

  // 
  do
  {
    int x, y, cnt;
    for ( y = 0; y < 8; y++ )
    {
      x = 0;
      while ( x < 8 )
      {
        cnt = 0;
        while ( x < 8 && g.pos[y * 8 + x] == NOPIECE )
        {
          x++;
          cnt++;
        }
        if ( cnt > 0 ) * s++ = '0' + cnt;
        while ( x < 8 && g.pos[y * 8 + x] != NOPIECE )
        {
          * s++ = ch_piece[g.color[y * 8 + x]] [g.pos[y * 8 + x]];
          x++;
        }
      }
      if ( y < 7 ) * s++ = '/';
    }
  }
  while ( 0 );


  //  
  * s++ = ' ';
  if ( g.side == WHITE ) * s++ = 'w';
  else
    * s++ = 'b';
  * s++ = ' ';

  // 
  do
  {
    int LeftCastlEnable( int c );
    int RightCastlEnable( int c );
    char * p = s;

    if ( LeftCastlEnable( WHITE ) ) * s++ = 'Q';
    if ( RightCastlEnable( WHITE ) ) * s++ = 'K';
    if ( LeftCastlEnable( BLACK ) ) * s++ = 'q';
    if ( RightCastlEnable( BLACK ) ) * s++ = 'k';

    if ( p == s ) * s++ = '-';
  }
  while ( 0 );
  * s++ = ' ';
  //   -   ,
  //        

  do
  {
    int PawnFirstExtMove( Move mv, int c );
    extern const char * chb[];
    Move mv = LastMove();
    if ( PawnFirstExtMove( mv, g.xside ) )
    {
      int sq = FROM( mv ) + dP[g.side];
      * s++ = chb[sq] [0];
      * s++ = chb[sq] [1];
    }
    else
      * s++ = '-';
  }
  while ( 0 );


  /*      */
  for ( s--; * s == ' ' || * s == '-'; s-- );
  s++;
  * s = '\0';
}

int LeftCastlEnable( int c )
{
  if ( c == WHITE )
  {
    if ( g.pos[E1] == KING && g.color[E1] == WHITE && g.pos[A1] == ROOK && g.color[A1] == WHITE
         && ( g.castl_enable & WHITE_LEFT_CASTL_ENABLE ) )
           return 1;
  }
  else
  {
    if ( g.pos[E8] == KING && g.color[E8] == BLACK && g.pos[A8] == ROOK && g.color[A8] == BLACK
         && ( g.castl_enable & BLACK_LEFT_CASTL_ENABLE ) )
           return 1;
  }
  return 0;
}

int RightCastlEnable( int c )
{
  if ( c == WHITE )
  {
    if ( g.pos[E1] == KING && g.color[E1] == WHITE && g.pos[H1] == ROOK && g.color[H1] == WHITE
         && ( g.castl_enable & WHITE_RIGHT_CASTL_ENABLE ) )
           return 1;
  }
  else
  {
    if ( g.pos[E8] == KING && g.color[E8] == BLACK && g.pos[H8] == ROOK && g.color[H8] == BLACK
         && ( g.castl_enable & BLACK_RIGHT_CASTL_ENABLE ) )
           return 1;
  }
  return 0;
}


int PawnFirstExtMove( Move mv, int c )
{
  if ( PIECE( mv ) == PAWN )
  {
    if ( ( ROW( FROM( mv ) ) == ( c == WHITE ) ? 6 : 1 ) && ( ROW( TO( mv ) ) == ( c == WHITE ) ? 4 : 3 ) )
      return 1;
  }
  return 0;
}

/*        */
int ListLibMoves( int treeLow, int treeHigh, Node * v[], Move moves[], int * n )
{
  Node * p;
  int j;

  * n = 0;
  for ( j = treeLow; j <= treeHigh; j++ )
  {
    int move_back = g.game_cnt >= 2 &&
                    TO(tree[j]) == FROM(g.game_list[g.game_cnt-2]);
    if( !move_back)
    {
       MakeMove( tree[j] );    
       p = SearchCurrPos();
       if ( p )
       {
 
          v[* n] = p;            // !!!  
          moves[* n] = tree[j]; //,    
          ( * n ) ++;
       }
       UnMakeMove( tree[j] );       
    }   
  }
  return ( * n ) > 0;
}



/*    
      
       

*/
Move MoveFromLib( int treeLow, int treeHigh )
{
  Move moves[512]; //  
  Node * v[512];   // ,     
  int n;
  int all_lib_cnt = 0;

  if ( ListLibMoves( treeLow, treeHigh, v, moves, & n ) )
  {
    int min = INT_MAX;
     
    do{                             //  get max value - min for opponent
      int j;
      for(  j = 0; j < n; j++)
       if ( v[j]->isFromLib )
       {
          all_lib_cnt++;
          if( v[j]->learn < min ) 
             min = v[j]->learn;
       }     
    }while(0);
    
    do{                             //  pick all max-moves 
      int j;
      int k = 0;
      for(j = 0; j < n; j++)
       if ( v[j]->isFromLib && 
            v[j]->learn == min )
       {      
          moves[k] = moves[j];
          v[k] = v[j];
          k++;
       }     
       
                                   // get random moves
                          
       if( k > 0 ){
         if(all_lib_cnt == 1 && min > 3) // one bad move - why its do?
            return 0;         
         return moves[ rand()%k ];                            
       }  
    }while(0);    
  }  
  return 0;  
}


int SaveLearnTable( char * fname )
{
  FILE * f = fopen( fname, "wb" );
  if ( f )
  {
    int j;
    for ( j = 0; j < SZ; j++ )
    {
      Node * p = learn[j];
      while ( p )
      {
        fwrite( p, 1, p->size, f );
        p = p->next;
      }
    }

    fclose( f );
    return 1;
  }
  return 0;
}

/*  ,      Node, (    )
      learn. */
int LoadLearnTable( char * fname )
{
  FILE * f = fopen( fname, "rb" );
  char msg[64] = "unknow error";
  printf("# load learn file--> %s - ", fname);
  if ( f )
  {
    Node * p;
    char * buf;
    int add_size, tmp;
    int f_size;
//    int readCnt = 0;
    //get file-size
    fseek( f, 0, SEEK_END );
    f_size = ftell( f );
    fseek( f, 0, SEEK_SET );
    //get memory
    buf = malloc( f_size );
    if ( buf == 0 ){
      strcpy(msg,"out of mem.");
      goto error;
    }  
    //read file
    do
    {
      tmp = fread( buf, 1, sizeof( Node ), f );
      if ( tmp == 0 ) goto success;
      if ( tmp != sizeof( Node ) ){
       strcpy(msg,"file spoiled");
        goto error;
      }  
      p = ( Node * ) & buf[0];
      add_size = p->size - sizeof( Node );
      if ( add_size <= 0 ){
        strcpy(msg,"file spoiled");
         goto error;
      }   
      if ( fread( buf + sizeof( Node ), 1, add_size, f ) != ( unsigned )add_size )
      {
        strcpy(msg,"file spoiled");
        goto error;
      }  
      buf += p->size;
 //     readCnt += p->size;
      p->next = learn[( int )p->key & ( SZ - 1 )];
      learn[( int )p->key & ( SZ - 1 )] = p;

    }
    while ( 1 );


  success:
    fclose( f );
    printf(".... done\n");
    return 1;
  error:
    printf(".... error: %s\n",msg);
    fclose( f );
  }else printf(" file not found\n");
  return 0;


}


void SaveSearchResult( int score, int depth )
{
  Node * p = SearchCurrPos();
  if ( p )
  {
      p->depth = depth;
      p->score = score;
      return;
  }else{
     char epd[256];
     MakeEpd( epd );
     p = NewLNode( epd );
     p->next = learn[( int )g.key & ( SZ - 1 )];
     learn[( int )g.key & ( SZ - 1 )] = p;

     p->score = score;
     p->learn = 0;
     p->c = g.side;
     p->depth = depth;
     p->isFromLib = 0;
  }   
}

/*        -  */
Node* SearchCurrPos(void){
  Node * p = learn[( int )g.key & ( SZ - 1 )];
  char epd[256];
  int isMakeEpd = 0;
  while ( p )
  {
    if ( p->key == g.key && p->c == g.side )
    {
      if(isMakeEpd == 0)
      {
        MakeEpd( epd );
        isMakeEpd = 1;
      }  
      if ( strcmp( epd, p->epd ) == 0 )
        return p; // exact position
    }
    p = p->next;
  }
  return NULL;  
}



/*      */
int LearnLook( int depth, int alpha, int beta, int * ret_score )
{
  Node * p = SearchCurrPos();
  if(p)
  {
        if ( p->depth >= depth )
        {
          * ret_score = p->score;
          return 1;
        }
        else if ( p->isFromLib )
        {
          int margin = 16;
          int score = p->learn/10; // score is beside 0
          if(score < -32) score = -32;
          if(score > 32) score = 32;
          
          if ( score + margin <= alpha )
          {
            * ret_score = alpha;
            return 1;
          }else if ( score - margin >= beta )
          {
            * ret_score = beta;
            return 1;
          }

        }
   }     
   return 0;
}


 

 
 

