#ifndef learnH_included
#define learnH_included

/* 
   @author Korniloff E.
     2007
*/

#include <string.h>
//#include <values.h>
#include <limits.h>
#include "chess.h"

 
/*
   .
       .
       ,
      0.
   <learn>      
     . (     -
  , , )
 */
 
typedef struct LearnNode
{
  int score,   //  (    - depth > 0)
       learn,  //
       c,      //  
       depth,  //  (    - 0)
       size,   //  ( -     )
       isFromLib; //   1..0
  struct LearnNode * next; //  
  HashKey key;    //  
  char epd[1];    //..size    
}
Node;

typedef struct TokType
{
  int hlat[256];
  char * begin, * end;
}
TokType;

void LearnClear(void);
Move MoveFromLib( int treeLow, int treeHigh ); 
int SaveLearnTable( char * fname );
int LoadLearnTable( char * fname );
void SaveSearchResult( int score, int depth );


Node* SearchCurrPos(void);
int LearnLook( int depth, int alpha, int beta, int * ret_score );
 


Node * NewLNode( char * epd );
void InitToken( TokType * p, char * s, char * del );
char * GetToken( TokType * p );
void ReadLibFile( char * fname );
int GetStr( char * s, int n, FILE * f );
void InsertCurrPositionToLearn( void );
//Node * GetEntry( int c, HashKey key );
void MakeEpd( char * s );
int LeftCastlEnable( int c );
int RightCastlEnable( int c );
int PawnFirstExtMove( Move mv, int c );
int ListLibMoves( int treeLow, int treeHigh, Node * v[], Move moves[], int * n );









#endif

