/* 
   @author Korniloff E.
     2007
*/


#include "chess.h"
#include "learn.h"

//#define LEARN_FILE "learnch_p_100.dat"
//#define BOOK_FILE "Kaissa.bk"
//#define LOG_FILE  "obender.log"




void PlayWinBoard( char * prog_dir )
{
  char s[1024];
#define LEX_IS(s)  (strcmp(s,lex)==0)
  void InitNewGame( void );
  int StrToMove( char * s, Move * ret_mv );
  int SearchMove( FullMove * ret );
  int InitGame( char * epd );
  void ReadLibFile( char * fname );
  int SaveLearnTable( char * fname );
  int LoadLearnTable( char * fname );
  char games_file_name[1024], book_file_name[1024], learn_file_name[1024],
       log_file_name[1024] ;
  Move mv;
  FullMove search_result;
  int stop = 0;
  int prev_inst = prog_is_run();
  int white, black, new_limit, cnt;
  
//  printf("-------->  %d \n", prev_inst);

  setbuf( stdout, NULL );
  setbuf( stdin, NULL );

  InitAllVar();
  InitNewGame();
  
  
  printf("#*******  CHESS ENGINE (WinBoard) ******\n");
  printf("# %-10s  %s  \n",   "name",    PROG_NAME); 
  printf("# %-10s  %s  \n",   "version", VERSION); 
  printf("# %-10s  %s  \n",   "author",  AUTHOR); 
  printf("# %-10s  %s  \n",   "site",    SITE); 
  printf("# %-10s  %s  \n",   "mail",    MAIL); 
  printf("# %-10s  %s  \n",   "data",    DATA_WRITE); 
  printf("#***************************************\n");   
  printf("# \n");        


  sprintf( games_file_name, "%s%s_games.pgn", prog_dir, PROG_NAME);
  sprintf( book_file_name, "%s%s.boo", prog_dir, PROG_NAME );
  sprintf( learn_file_name, "%s%s.lrn", prog_dir, PROG_NAME );
  sprintf( log_file_name, "%s%s.log", prog_dir, PROG_NAME );


  //load learn table
  if ( LoadLearnTable( learn_file_name ) == 0 ) {
    LearnClear();
    ReadLibFile( book_file_name );

  }

  //init interface with arena (winboard)
  printf( "feature setboard=1\n" );
  printf( "feature done=1\n" );

   /*
  ////////
  do{
    int TestGetFirst(void);
    printf("test bits: %d\n",   TestGetFirst());
  }while(0);
   ////////
     */
  while ( fgets( s, sizeof( s ) - 1, stdin ) )
  {
    char * lex = strtok( s, " \n" ), * pen;//= "rnbqkbnr/pppp1ppp/8/4p3/4P3/8/PPPP1PPP/RNBQKBNR w KQkq e6 0 2";
    //= "r4rk1/4Rp2/6p1/1p1p1bNp/p1qP3P/2P1Q3/P4PP1/4R1K1 b"; // - - 0 0";

    if ( lex )
    {
	  if ( LEX_IS( "quit" ) )
	  {
			
	    break;
	  }
	  
	   else if( LEX_IS( "white") )         // added for computer color flag 
      {                             // needed for time fix below - JA
              int white = 1;
              int black = 0;
              
              }
              
      else if( LEX_IS( "black") )   // added for computer color flag 
      {                             // needed for time fix below - JA
              black = 1;
              white = 0;
              
              }        
      	  
	    
	  
      else if ( LEX_IS( "st" ) )
      {
        extern time_t limit_time,ext_time;
        char * s = strtok( 0, " \n" );
        limit_time = 7.5 * 100;
        ext_time = 0; 
        if(s)
        {
          limit_time = atoi( s ) * 100;
          if( limit_time < 1.0 * 100 )
            limit_time = 1.0 * 100;  
		  ext_time = 3*limit_time;
        }  
		limit_time /=10;
      
      }
      /*
      else if( LEX_IS( "time") )
      {
        extern time_t limit_time, ext_time;
        char * s = strtok( 0, " \n" );
        limit_time = 7.5 * 100; 
        ext_time = 0;
        if(s){
          int t = atoi( s );
          int cnt = 40 - (g.game_cnt/2) % 40;
          limit_time = t / cnt;
          if( cnt > 10)  // ext-time 
          {
            ext_time = max( 0,   t - cnt * 6.0*100);
          }
          if(g.side == BLACK  &&  cnt == 1)
            limit_time = 3 * 100; // shit
          if( limit_time < 1.0 * 100 )
            limit_time = 1.0 * 100;
          if( limit_time > 30.0 * 100 )
            limit_time = 30.0 * 100; 
		  if(ext_time > limit_time*3)
			ext_time = limit_time*3;
        }
      }
      */
      else if( LEX_IS( "time") )
      {
        extern time_t limit_time, ext_time;
        char * s = strtok( 0, " \n" );
        limit_time = 7.5 * 100; 
        ext_time = 0;
        if(s){
          int t = atoi( s );
          int cnt = 40 - (g.game_cnt/2) % 40;
          limit_time = t / cnt;
          if( cnt > 10)  // ext-time 
          {
            ext_time = max( 0,   t - cnt * 6.0*100);
          }
            
            if (black == 1) {       // fix for 'timeout playing as black bug' - JA
            cnt = 40 - ((g.game_cnt-2)/2) % (40-2); 
            }else{
            cnt = 40 - (g.game_cnt/2) % 40; 
            }
            
            new_limit = t / cnt;
            limit_time = new_limit;
           // if(limit_time < 2.5 * 100) limit_time = 2.5 * 100;
           // else 
           if(limit_time < 2.5 * 100) limit_time = 0;  // - JA
           else
           if(limit_time > 40 * 100) {
           //limit_time = 40 * 100;                // - JA
            cnt = 40;
            new_limit = t / cnt;
            
            }

}
limit_time = new_limit/10;

}
      
      else if ( LEX_IS( "score" ) )
      {
        int Evaluate( int alpha, int beta );
        void InitEvaluate( void );

        InitEvaluate();
        printf( "# %d\n", Evaluate( -INF, INF ) );

      }
      else if ( LEX_IS( "force" ) )
      {

        stop = 1;

      }
      else if ( LEX_IS( "undo" ) )
      {

        if ( g.game_cnt > 0 )
        {
          Move mv = g.game_list[g.game_cnt - 1];
          UnMakeMove( mv );
          g.game_list[g.game_cnt - 1] = mv;
          g.game_cnt--;
          ply = 0;
        }
        
      }
      else if ( LEX_IS( "redo" ) )
      {

        if ( g.game_cnt < g.game_max )
        {
          MakeMove( g.game_list[g.game_cnt] );
          g.game_cnt++;
          ply = 0;

        }

      }
      else if ( LEX_IS( "new" ) )
      {
        InitNewGame();

      }
      else if ( LEX_IS( "protover" ) )
      {
        printf( "feature time=1 colors=1 done=1\n" );
      }

      else if ( LEX_IS( "deb" ) )
      {
         char *p = strtok(NULL," \n"); 
		 char *pos = "";
         if(p)
		  switch(atoi(p))
		  {
		     case 1:  pos = "r4rk1/4Rp2/6p1/1p1p1bNp/p1qP3P/2P1Q3/P4PP1/4R1K1 b - - 0 0";
				      break;
		     case 2:  pos = "r1bq1r1k/ppp2pp1/2nbp2p/6NQ/3P4/2PB4/P1P2PPP/R1B2RK1 b - - 0 12";
				      break;
		     case 3:  pos = "2r2b1r/p1qk1ppp/2p1pn2/1B6/Pp6/4PP2/1PQB1P1P/2R2RK1 w - - 0 16 "; 
				      break;
		     case 4:  pos = "r5k1/7p/1Rp2rp1/2Pp4/P2Qp3/4PqP1/3R1P1P/6K1 w - - 0 38";
				      break;
		  }
         
		 if(InitGame(pos)==0) fprintf(stderr,"#error\n");
      }
      else if ( LEX_IS( "setboard" ) &&  (pen = strtok(NULL,"\n")) != NULL
           && InitGame( pen ) )
      {
      }
      else if ( StrToMove( lex, & mv ) && InsertMoveInGame( mv ) )
      {
        int search_side = g.side;
 
        if(Repetition())
          printf("# ---> repetition found    \n");
        
        
        if ( !stop )
          if ( SearchMove( &search_result ) && InsertMoveInGame( search_result.mv ) )
          {
            char str_move[64];
            char * MoveToStr( Move mv, char * str );
            int resign;
          
            resign = 0;
            do{ // check game result down
              static int old_game_cnt, old_side, old_score;
              static int down_cnt;
            
              if(g.game_cnt != old_game_cnt + 2 ||
                 old_side != search_side ||
                 search_result.score > -50 ||
                 search_result.score > old_score
                 ){
                 
                 down_cnt = 0;
              }else{
              
                 down_cnt++;
                 if(down_cnt >= 3 ||      // learn
                    search_result.score < -INF+100)
                 {
                   if(g.isLearn == 0)
                   {
                     int j;
         ///???
           {
             FILE *f = fopen(log_file_name,"a");
             if(f){
               fprintf(f, "score is down: score %d; moves %d; side %s, try learn \n",
                       search_result.score,
                       g.game_cnt/2,
                       search_side==WHITE?"white":"black"
                       );
               fclose(f);
             }
           }
         ///???
                     for( j = 0; j < g.game_cnt; j++)
                     {
                       Node *ln = (Node*)g.learn_node_list[j];
                       if(ln){
                          if( ln->c == search_side )
                            ln->learn--;
                          else
                            ln->learn++;  
                       }     
                     }
                     g.isLearn = 1;
                   }            
                    
                 }   
                 if(down_cnt >= 3){       // resign
                   if(search_result.score < -VALUE_Q)
                   {
                     g.resignCnt++;
                     resign = g.resignCnt;
                     
///???
 // printf("value %d, max %d \n", search_result.score, VALUE_Q);
///???                     
                   }   
                 }
              }
              old_game_cnt = g.game_cnt;
              old_side = search_side;
              old_score = search_result.score;
            }while(0);            
            
            if(resign == 1)  // thanks JA :)
            {
              printf("%s thinking about resigning\n",PROG_NAME);
            }else if(resign == 2){
   ///???
           {
             FILE *f = fopen(log_file_name,"a");
             if(f){
               fprintf(f, "%s resigns, score %d; cnt %d\n",
                       search_side==WHITE?"white":"black",
                       search_result.score,
                       g.game_cnt/2
                       );
               fclose(f);
             }
           }
  ///???            
                printf("%s resigns\n",PROG_NAME);
                printf("computer resigns\n");
            }
//       printf("%d\n",  search_result.score);    
            printf( "move %s%s\n", 
                   MoveToStr( search_result.mv, str_move),
                   search_result.score == (INF-2) ? "# \ncomputer mated" : "" // used in 'sending mate result' - JA
                   );
          
          }




      }
      else if ( LEX_IS( "go" ) && SearchMove( & search_result ) && InsertMoveInGame( search_result.mv ) )
      {
        char str_move[64];
        char * MoveToStr( Move mv, char * str );

                    
            printf( "move %s%s\n", 
                   MoveToStr( search_result.mv, str_move),
                   search_result.score == (INF-2) ? "# \ncomputer mated" : "" // used in 'sending mate result' - JA
                  ); 
        stop = 0;
      }
      else
      {
        fprintf( stderr, "#error: %s\n", lex );
      }



    } //if lex
  } //while

  do{  // SAVE LEARN FILE
    
    if(prev_inst==0)
    {      
      SaveLearnTable( learn_file_name );

    }else{
      FILE *f = fopen(log_file_name,"a");
      if(f)
      {
         fprintf(f,"error write learn---> 2 prog. run \n");
         fclose(f);       
      }   
    }  
  
  }while(0);
  
  if(strcmp(g.fen, START_POS_FEN) == 0 )
  do{                          // append game to text-file
    char * MoveToStr( Move mv, char * str );
    int j;
    FILE *f = fopen(games_file_name,"a");
    char move[64];
    if(f){
      for(  j = 0; j < g.game_max; j++)
      { 
        Node *learn_node = ((Node*)g.learn_node_list[j]);
        MoveToStr(g.game_list[j], move);
        if((j & 1)==0)
         fprintf(f," %d. ", j/2 + 1); 
        fprintf(f,"%s", move);
        if( learn_node && learn_node->depth > 0 )
          fprintf(f, "{%d}", 
                  learn_node->c==WHITE ? learn_node->score : -learn_node->score);
                  
        fprintf(f," "); 
      }
      fprintf(f,"\n");
      fclose(f);
    }
  }while(0);
}

