/* 
   @author Korniloff E.
     2007
*/


#include <stdio.h>
#include <limits.h>
#include "chess.h"
#include "bitmask.h"


//#define DEBUG


int s_depth, doNull,doReduction,iteration,use_null;
int hist_to[32][64];
int cnt50moves;
#define MAX_HIST  10000
#define MAX_SORT_VAL  (MAX_HIST + VALUE_Q*2)
 

extern time_t start_time, curr_time, limit_time, ext_time;
extern int is_stop_search;
extern int search_result,search_depth;
extern U64 cnt_nodes;



Line kill0,kill1,kill2,kill3,kill4,old_pv;

#define MTL(c)   (g.mtl[c] - g.mtl[c^1])
#define ROOT_MTL(c)   (root_mtl[c] - root_mtl[c^1])
void SortMoves(int kill0,int kill1, int kill2, int kill3, 
               int kill4, int low, int high);

int mtl_path[MAX_PLY];


int Search( int alpha, int beta, int depth,
		    int check, Line ret_pv_line, int do_null)
{
  int Quies( int alpha, int beta, int check );
  int StopSearch( void );
  int Evaluate( int alpha, int beta );
  int HashLook( int alpha, int beta, int depth, int * ret_score, Move * ret_mv );
  void HashInsert( int alpha, int beta, int depth, Move mv );
  int Check( void );
  void SaveHist( Move mv, int alpha, int beta );
  void SavePvLine( Line dest, Line source, Move mv );
  Move LastMove( void );
  int Repetition( void );
  int LegalCastl( Move mv );
  void SaveRootScore( int alpha, int beta, Move mv, int depth, Line line );
  int LearnLook( int depth, int alpha, int beta, int * ret_score );
//  int CanRepetition(Move last, int c);
  int score;
  int static_score;
  Move mv = 0, best_mv = 0;
  Line tmp_line;
  int c0 = g.side, c1 = c0^1;
  Move last = LastMove();
  int j;
  Move hash_mv=0,pv_mv=0;
  int mate_threat=0;
  
  mtl_path[ply] = MTL(c0);
  if(!doNull)
   if( kill0[ply] ){
    pv_mv = kill0[ply];
    kill0[ply] = 0;
   }

  if(  -INF + ply + 1 >= beta   &&  ply > 0 ) 
      return beta; // function  up

  if ( StopSearch() ) return 0;
  if ( depth <= 0  )  return Quies( alpha, beta,check ); //   


  if ( ply > MAX_PLY - 4 ) return Evaluate( alpha, beta );
  if( ply > 0 && (last&CAPTURE)==0 && Repetition() ) return 0;
  if ( ply > 4 && !doNull  && LearnLook( depth, alpha, beta, & score ) )
       return score;
  if ( ply > 0 && HashLook( alpha, beta, depth, &score, &hash_mv ) ) 
      return score;

 

 if(doReduction)
    if( !do_null && use_null && !check && ply > 2
       && (static_score=Evaluate(alpha,beta )) >= beta
       )do{
      int saveDoNull = doNull,tmp;

	    // static_score=Evaluate(alpha,beta );
		 
         if(static_score >= beta   && depth <= 2 && !doNull && doReduction)
            return beta;
		 /*
		 if(static_score <= alpha )
		 {
			 if(depth <= 1)
			     return Quies(alpha,beta,check);
			// if(depth <= 3 && Evaluate(alpha-501,alpha-499) < alpha-500)
			//	 return Quies(alpha,beta,check);
		 }
			*/
		//if(static_score < beta) break;
        
        doNull = 1;
        treeCnt[ply + 1] = treeCnt[ply];
        MakeMove( 0 );
        tmp_line[ply] = 0;
        
        tmp = -Search( -beta, -(beta-1), depth-3, 
               check, tmp_line, 1);

        UnMakeMove( 0 );
        doNull = saveDoNull;
        if(tmp >= beta) return beta;
       if(tmp < beta  &&  beta > -INF+100 && tmp < -INF+100)
          mate_threat = 1;
    }  while(0);
  



 
  do{
   int legalCnt = 0;
   int oneReply = 0;



if(ply > 0)
{

 if(check){
    int LegalMoveList(void);
    if ( LegalMoveList() == 0 ) return INF - ply; //CAP. OP. KING
    else if ( treeCnt[ply + 1] == treeCnt[ply] ) return -INF + ply + 1; // mate
    else if ( treeCnt[ply + 1] == treeCnt[ply] + 1 ) oneReply = 1;
 }else{

    if ( Generate() == 0 ) return INF - ply; //CAP. OP. KING
    else if ( treeCnt[ply + 1] == treeCnt[ply] ) return 0; // ?? not realy
 }
  SortMoves(pv_mv?pv_mv:hash_mv,
            kill1[ply],kill2[ply],kill3[ply],kill4[ply],
            treeCnt[ply],treeCnt[ply+1]-1);
}

    
    for(j = treeCnt[ply]; j < treeCnt[ply+1]; j++)
    {
      int nextCheck, nextDepth = depth - 1, cutt_off = 0;
      int add = 0, threat = 0;

      
      Pick(j,treeCnt[ply+1]-1);
      mv = tree[j];

      if ( ( mv & ( LEFT_CASTL | RIGHT_CASTL ) ) && !LegalCastl( mv ) )
        continue;
      MakeMove( mv );
 
      if ( SqAttack( g.kingSq[g.xside], g.side ) )
      { // illegal move
          UnMakeMove( mv );
          continue;
      }
      legalCnt++;
      nextCheck = Check();


      if(1)
      {

        if ( nextCheck ){
           add += 1;
           threat = 1;
        }
        if ( PIECE( mv ) == PAWN && ( ROW( TO( mv ) ) == ( c0 == WHITE ? 1 : 6 ) ) )
        {
           add += 1;
           threat = 1;
        }
        if( oneReply ) add += 1;
        if(mate_threat){
           add += 1;
           threat = 1;
        }   
       
        if(add > 1) add = 1;
        nextDepth  = nextDepth + add;
      }
      
    
   
   if(legalCnt==1 || nextDepth <= 0)
   {
       tmp_line[ply] = 0;		 
       score = -Search( -beta, -alpha, nextDepth, nextCheck,
                       tmp_line,0);   
   }else{
       int save = doReduction;
     
       int lmr = legalCnt > 3 && 
		   !threat && depth>2 && !check
		         &&  sort_val[j] < MAX_HIST;
		        // && (mv & CAPTURE)==0;// && !check;
		  

       doReduction = lmr;
       tmp_line[ply] = 0;

	   //if( (mv&CAPTURE)==0 )
		   //lmr <<= 1;

       score = -Search( -(alpha+1), -alpha, nextDepth-lmr, nextCheck,
                       tmp_line,0);      
                       
       doReduction = save;                
      if(score > alpha  &&  (score < beta || lmr ))
      {
        tmp_line[ply] = 0;
       score = -Search( -beta, -alpha, nextDepth, nextCheck,
                       tmp_line,0);         
      }
   }

 
//skipSearch:
      UnMakeMove( mv );

      if ( is_stop_search ) return 0;

      if ( !cutt_off && score > alpha )
      {

        best_mv = mv;
        alpha = score;
        if ( TO( mv ) != TO( last ) ) 
           if(kill1[ply] != mv)
           {
             kill2[ply] = kill1[ply];
             kill1[ply] = mv;
             kill1[ply] = mv;
            }
        
 
        SaveHist( mv, alpha, beta );
        
        if ( alpha < beta )//|| ply==0)
        {
         if(ply==0) memset( ret_pv_line, 0, sizeof(Line));
         SavePvLine( ret_pv_line, tmp_line, mv );
         if(ply == 0)
         {
		   extern void insert_search_result(int score, int depth );


            sort_val[j] = 1000000 + iteration*100 + legalCnt;
            search_result = alpha;
            search_depth  = depth;             
            PrintSearchStatus(depth,alpha,
                     ( int )( curr_time - start_time ),
                      cnt_nodes, ret_pv_line );
			insert_search_result(alpha,depth);
         }  
        }  
        
        if(alpha >= beta)
          break;
      }
    } //while

    if ( legalCnt == 0 )
    {
      if ( !check ) return 0; //STALEMATE
      return -INF + ply + 1; //MATE
    }

  }while(0);
  if ( ply > 0 )
    HashInsert( alpha, beta, depth, best_mv );

  return alpha;
}

 
//////////  main search ////
int main_search( int alpha, int beta, int depth,
		         int check, Line ret_pv_line, int do_null, Move *ret_best)
{
  int Quies( int alpha, int beta, int check );
  int StopSearch( void );
  int Evaluate( int alpha, int beta );
  int HashLook( int alpha, int beta, int depth, int * ret_score, Move * ret_mv );
  void HashInsert( int alpha, int beta, int depth, Move mv );
  int Check( void );
  void SaveHist( Move mv, int alpha, int beta );
  void SavePvLine( Line dest, Line source, Move mv );
  Move LastMove( void );
  int Repetition( void );
  int LegalCastl( Move mv );
  void SaveRootScore( int alpha, int beta, Move mv, int depth, Line line );
  int LearnLook( int depth, int alpha, int beta, int * ret_score );
//  int CanRepetition(Move last, int c);
  int score;
  int static_score;
  Move mv = 0, best_mv = 0,tmp_mv;
  Line tmp_line;
  int c0 = g.side, c1 = c0^1;
  Move last = LastMove();
  int j;
  Move hash_mv=0,pv_mv=0;
  int mate_threat=0;
  
  mtl_path[ply] = MTL(c0);
   

  if( kill0[ply] ){
    pv_mv = kill0[ply];
    kill0[ply] = 0;
  }

  if(  -INF + ply + 1 >= beta   &&  ply > 0 ) 
      return beta; // function  up

  if ( StopSearch() ) return 0;
  if ( depth <= 0  )  return Quies( alpha, beta,check ); //   


  if ( ply > MAX_PLY - 4 ) return Evaluate( alpha, beta );
  if( ply > 0 && (last&CAPTURE)==0 && Repetition() ) return 0;
  if ( ply > 4  && LearnLook( depth, alpha, beta, & score ) )
       return score;
  if ( ply > 0 && HashLook( alpha, beta, depth, &score, &hash_mv ) ) 
  {
	  //return score;
  }
    
  if((pv_mv)==0 && ply==1 
	  && depth > 2)
  {
       tmp_line[ply] = 0;		 
       score = main_search( alpha, beta, depth-1,check,
                       tmp_line,0,&hash_mv); 
	   if(score > INF-100 && score > alpha && ply > 6)
	   {
		   if(ret_best) *ret_best = hash_mv;
		   return score;
	   }
	   pv_mv = hash_mv;

	   
  }
	  

 
  do{
   int legalCnt = 0;
   int oneReply = 0;



if(ply > 0)
{

 if(check){
    int LegalMoveList(void);
    if ( LegalMoveList() == 0 ) return INF - ply; //CAP. OP. KING
    else if ( treeCnt[ply + 1] == treeCnt[ply] ) return -INF + ply + 1; // mate
    else if ( treeCnt[ply + 1] == treeCnt[ply] + 1 ) oneReply = 1;
 }else{

    if ( Generate() == 0 ) return INF - ply; //CAP. OP. KING
    else if ( treeCnt[ply + 1] == treeCnt[ply] ) return 0; // ?? not realy
 }
  SortMoves(pv_mv?pv_mv:hash_mv,
            kill1[ply],kill2[ply],kill3[ply],kill4[ply],
            treeCnt[ply],treeCnt[ply+1]-1);
}

    
    for(j = treeCnt[ply]; j < treeCnt[ply+1]; j++)
    {
      int nextCheck, nextDepth = depth - 1, cutt_off = 0;
      int add = 0, threat = 0;

      
      Pick(j,treeCnt[ply+1]-1);
      mv = tree[j];

      if ( ( mv & ( LEFT_CASTL | RIGHT_CASTL ) ) && !LegalCastl( mv ) )
        continue;
      MakeMove( mv );
 
      if ( SqAttack( g.kingSq[g.xside], g.side ) )
      { // illegal move
          UnMakeMove( mv );
          continue;
      }
      legalCnt++;
      nextCheck = Check();


      if(1)
      {

        if ( nextCheck ){
           add += 1;
           threat = 1;
        }
        if ( PIECE( mv ) == PAWN && ( ROW( TO( mv ) ) == ( c0 == WHITE ? 1 : 6 ) ) )
        {
           add += 1;
           threat = 1;
        }
        if( oneReply ) add += 1;
        if(mate_threat){
           add += 1;
           threat = 1;
        }   
       
        if(add > 1) add = 1;
        nextDepth  = nextDepth + add;
      }
      
    
   
   //if(legalCnt==1 || nextDepth <= 0)
  if(mv==pv_mv || nextDepth <= 0)
   {
       tmp_line[ply] = 0;		 
       score = -main_search( -beta, -alpha, nextDepth , nextCheck,
                       tmp_line,0,&tmp_mv);   
   }else{


       tmp_line[ply] = 0;
       score = -Search( -(alpha+1), -alpha, 
		               nextDepth ,   
					 // use_null ?  min( max(s_depth-4,6), nextDepth) : nextDepth ,
		               nextCheck, tmp_line, 0 );      
                       
                    
      if( score > alpha )
      {
        tmp_line[ply] = 0;
       score = -main_search( -beta, -alpha, nextDepth, nextCheck,
                       tmp_line,0,&tmp_mv);         
      }
   }

 
//skipSearch:
      UnMakeMove( mv );

      if ( is_stop_search ) return 0;

      if ( !cutt_off && score > alpha )
      {

        best_mv = mv;
        alpha = score;

		if(ret_best) *ret_best = mv;

        if ( TO( mv ) != TO( last ) ) 
           if(kill1[ply] != mv)
           {
             kill2[ply] = kill1[ply];
             kill1[ply] = mv;
             kill1[ply] = mv;
            }
        
 
        SaveHist( mv, alpha, beta );
        
        if ( alpha < beta )//|| ply==0)
        {
         if(ply==0) memset( ret_pv_line, 0, sizeof(Line));
         SavePvLine( ret_pv_line, tmp_line, mv );
         if(ply == 0)
         {
		   extern void insert_search_result(int score, int depth );


            sort_val[j] = 1000000 + iteration*100 + legalCnt;
            search_result = alpha;
            search_depth  = depth;             
            PrintSearchStatus(depth,alpha,
                     ( int )( curr_time - start_time ),
                      cnt_nodes, ret_pv_line );
			insert_search_result(alpha,depth);
         }  
        }  
        
        if(alpha >= beta)
          break;
      }
    } //while

    if ( legalCnt == 0 )
    {
      if ( !check ) return 0; //STALEMATE
      return -INF + ply + 1; //MATE
    }

  }while(0);
  if ( ply > 0 )
    HashInsert( alpha, beta, depth, best_mv );

  return alpha;
}

//// end main search ///////
  

int Quies( int alpha, int beta, int check )
{
  int GenerateCaptures( void );
  void Pick( int low, int high );
  int j;
  
  
  if ( StopSearch() ) return 0;
  if(  -INF + ply + 1 >= beta  ) 
      return beta; // function  up  
  if ( ply > MAX_PLY - 4 ) return Evaluate(alpha,beta);
  
  
  if(check)
  {
    int LegalMoveList(void);
    if ( LegalMoveList() == 0 ) return INF - ply; //CAP. OP. KING
    else if ( treeCnt[ply + 1] == treeCnt[ply] ) return -INF + ply + 1; // mate 
  }else{
    int score = Evaluate( alpha, beta );
    if ( score > alpha ) alpha = score;
    if ( score >= beta ) return alpha;
    if ( GenerateCaptures() == 0 ) return INF - ply;    
  }  
  
  SortMoves(0,0,0,0,0,
            treeCnt[ply],treeCnt[ply+1]-1);  


  for ( j = treeCnt[ply]; j < treeCnt[ply + 1]; j++ )
  {
        Move mv;
        int tmp;

        Pick( j, treeCnt[ply + 1] - 1 );
        mv = tree[j];
        if ( ( mv & ( LEFT_CASTL | RIGHT_CASTL ) ) && !LegalCastl( mv ) )
           continue;
        if(!good_cap(mv, sort_val[j], check)) 
           continue;
           
        MakeMove( mv );
        tmp = -Quies( -beta, -alpha,  Check() );
        UnMakeMove( mv );
        if ( tmp > alpha ) alpha = tmp;
        if ( alpha >= beta ) break;
  } //for
 



  return alpha;
}





void SaveHist( Move mv, int alpha, int beta )
{
  int incH = 1;
  int from = FROM(mv);
  int to = TO(mv);
  int i = g.index[from];

 
  
  if ( alpha > INF - 100 )
     incH += 4;
  hist_to[i][to] = min( hist_to[i][to] + incH, MAX_HIST );
 
}


int Repetition( void )
{
  int j,cnt,c,rep;

  cnt = 0;
  rep = 0;
  c=g.xside;
  for( j = g.game_cnt + ply - 1; // last move
       j >= 1;
       j--, c ^= 1)
  {
    Move mv = g.game_list[j];
    if( ( mv & (CAPTURE|PROMOTE|LEFT_CASTL|RIGHT_CASTL))
           | (mv == 0) 
           | (PIECE(mv) == PAWN)
        )   
        return 0;    
     if(c == g.side  && g.key_list[j-1]==g.key)   
     {
       rep++;
       if(j >= g.game_cnt || rep==2)
          return 1;
     }
     cnt++;
    if(cnt > 50*2) return 1; 
    if(j==g.game_cnt && cnt50moves + cnt > 50*2)
      return 1;    
  }     
  return 0;
}

 



void SortMoves(int kill0,int kill1, int kill2, 
               int kill3, int kill4, int low, int high)
{

  int j;
  Move last = LastMove();
        for ( j = low; j <= high; j++ )
        {
         Move mv = tree[j];
         int s = 0;       

 
          if ( mv&CAPTURE )
          {
            if ( mv & EN_PASSANT )
            {
              s += 2 * VALUE_P;
            }
            else
            {
             // s += value[g.pos[TO( mv )]] - PIECE( mv );
              
             // if ( TO( mv ) == TO( last ) ) s += VALUE_R;
               s += See(mv,g.side) - PIECE( mv ) + KING + 1;
               
               // if see is good --> s => 1..inf
               // win capture => 90..inf
            }
          }
          if ( mv & PROMOTE ) s += value[PIECE( mv )];
          if(mv==kill0) s = MAX_SORT_VAL;
          else if(mv==kill1) s += VALUE_P;
          else if(mv==kill2) s += 30;           
          else if(mv==kill3) s += 20;
          else if(mv==kill4) s += 10;
          
          if ( (s > 0)|(mv&(CAPTURE|PROMOTE)) ) s += MAX_HIST;
		  else s += hist_to[g.index[FROM(mv)]] [TO(mv)];
         sort_val[j] = s;           
        } //for
}

int good_cap(Move mv, int sort_val, int check){
  if(mv & PROMOTE) return 1;
  if(check) return 1;
  if(( mv & CAPTURE) && sort_val > MAX_HIST) return 1;
  return 0;
}

int win_cap(Move mv, int sort_val){
  if(mv & PROMOTE) return 1;
  if(( mv & CAPTURE) && sort_val > MAX_HIST+90) return 1;
  return 0;
}


void Pick( int low, int high )
{
  int m_i = low, max = sort_val[low], j;
  for ( j = low + 1; j <= high; j++ )
    if ( sort_val[j] > max )
    {
      max = sort_val[j];
      m_i = j;
    }

  if ( m_i != low )
  {
    SWAP( sort_val[low], sort_val[m_i] );
    SWAP( tree[low], tree[m_i] );
  }
}



void SavePvLine( Line dest, Line source, Move mv )
{
  int j;

  for ( j = ply + 1; j < MAX_PLY - 4 && source[j]; j++ )
    dest[j] = source[j];

  dest[ply] = mv;
  dest[j] = 0;
}


int SweepCnt(int c){

  return g.cnt[c][QUEEN] + g.cnt[c][ROOK] + g.cnt[c][BISHOP];
}
 

int SearchMove( FullMove * ret )
{
  void HistoryInit( void );
  void TimeReset( void );
  int StopSearch( void );
  const int MAX_DEPTH = MAX_PLY - 10;
  int d;
  void HashClear( void );
  void InitEvaluate( void );
  Move MoveFromLib( int treeLow, int treeHigh );
  int CanUseNullMove(void);
 

 

 

  //   

  TimeReset();
  srand( (unsigned)time( 0 ) );
  InitEvaluate();
  HashClear();
  HistoryInit();
  memset(kill0,0,sizeof(Line));
  memset(kill1,0,sizeof(Line));
  memset(kill2,0,sizeof(Line));    
  memset(kill3,0,sizeof(Line));    
  memset(kill4,0,sizeof(Line));
  memset(old_pv,0,sizeof(Line));


  use_null = CanUseNullMove();
  do{
    int j;
    cnt50moves = 0;
    for(j = g.game_cnt-1; j >= 0; j++)
    {
     Move mv = g.game_list[j];
     if( ( mv & (CAPTURE|PROMOTE|LEFT_CASTL|RIGHT_CASTL))
           | (mv == 0) 
           | (PIECE(mv) == PAWN)
         )   
          break;
       cnt50moves++;
    } 
  }while(0);


  do{
   int j;
     LegalMoveList();
     
     
    switch ( treeCnt[1] - treeCnt[0] ){
      case 0: return 0;  //  
      case 1:{            //  -   
         FullMoveInit(ret, 0, 0, 0, tree[0], NULL );
         return 1;
      }
    }     
     
     for ( j = 0; j < treeCnt[1]; j++ )
     {
       MakeMove( tree[j] );
       sort_val[j] = -Evaluate( -INF, INF );
       UnMakeMove( tree[j] );
     }  
  }while(0);
 
  //     
  srand((unsigned)time(0));
  do
  {
    
    const int prob[12] = {90,85,80,75,60,55,50,45,40,35,30,25};
    Move mv;
    int  cnt = min(11, g.game_cnt/2);
    int ok = rand()%100 <= prob[cnt]-10;


    if ( ok )
      if ( ( mv = MoveFromLib( treeCnt[0], treeCnt[1] - 1 ) ) != 0 )
      {
        FullMoveInit(ret, 0, 0, 0, mv, NULL );
        return 1;
      }
  }
  while ( 0 );




//  root_mtl[WHITE] = g.mtl[WHITE];
 // root_mtl[BLACK] = g.mtl[BLACK];


   
 do{
  int static_score = Evaluate(-INF,INF);
  int old_result = static_score;
  int a,b;
  iteration = 0;
  for ( d = 2; d <= MAX_DEPTH; d += ROOT_IID_INC )
  {
    int tmp;
    s_depth = d;
 
    iteration++;
    //a = min( old_result - 32, static_score - 32);
    //b = max( old_result + 32, static_score + 32);
    a = -INF;//old_result - 32;//16;
    b = INF;//old_result + 32;//32;
    tmp = //Search( a, b, s_depth, Check(), kill3,0);
		main_search( a, b, s_depth, Check(), kill3,0,NULL);
    if( is_stop_search ) break;
   // memmove(kill0,kill3,sizeof(Line));  
   
    if(tmp <= a){
       iteration++;
       tmp = main_search( -INF, b, s_depth, Check(), kill3,0,NULL);    
             //Search( -INF, b, s_depth, Check(), kill3,0);    
    }else if(tmp >= b){
       iteration++;
       memmove(kill0,kill3,sizeof(Line));       
       tmp = main_search( a, INF, s_depth, Check(), kill3,0,NULL);        
		   //Search( a, INF, s_depth, Check(), kill3,0);
    }

    if( is_stop_search ) break;
    old_result = tmp;
    memmove(kill0,kill3,sizeof(Line));
    memmove(kill4,old_pv,sizeof(Line));  
    memmove(old_pv,kill3,sizeof(Line));




    if(s_depth > 6 )
    {
	  extern int last_move_is_good(void);


      if ( tmp > INF - 100 ) break;
      if ( tmp < -INF+100 ) break; //  
	  if( last_move_is_good() )
        if ((curr_time - start_time) * 2 > limit_time)  
           break;      
    }  

     
	 do{
	   int i,sq;

	   for(i = 0; i < 32; i++) 
		 for(sq = 0;sq < 64; sq++)
				 hist_to[i][32] /= 2;
	 }while(0);
	   
     
  }//for d
}while(0);

//done:
  do{
    FullMove* FullMoveInit(FullMove *p, int depth, int score, int time, Move mv,
                       Move line[] );
    

    Pick(treeCnt[0],treeCnt[1]-1); 
    FullMoveInit(ret, search_depth ,
                      search_result,
                      curr_time - start_time,
                      tree[0],
                      kill3 );
  }while(0);



  SaveSearchResult( ret->score, ret->depth );


 

  return 1;
}

void HistoryInit( void )
{
 memset(hist_to,0,sizeof(hist_to));
}


