#include "chess.h"
#include "bitmask.h"

#define canCheckVal (14*comp_piece_val[VALUE_P])
//extern int comp_piece_val[];

int Threat(int p, int sq, int c){
#define GET_CAP_PAWN\
        if( g.color[to] == (c^1) ){                 \
          int val = comp_piece_val[g.pos[ to ]];             \
          if(promote)                               \
            m = max( m, (comp_piece_val[VALUE_Q] - comp_piece_val[VALUE_P]) + val );\
          else{                                     \
                m = max( m, val );                  \
          }                                         \
        } 
 int maxVal = 0;
 int to;
 if(p==PAWN)
 {
    int x = COLUMN(sq);
    int y = ROW(sq);
    int m = 0;
    if(c == WHITE){
      int promote = (y == 1);
      if(promote && g.color[sq-8]==NEUTRAL)
          m = (comp_piece_val[VALUE_Q] - comp_piece_val[VALUE_P]);
      if( x > 0 )
      {
        to = sq - 8 - 1;  
        GET_CAP_PAWN;
      }
      if( x < 7 )
      {
        to = sq - 8 + 1;  
        GET_CAP_PAWN;
      }      
    }else{ //BLACK
      int promote = (y == 6);
      if(promote && g.color[sq+8]==NEUTRAL)
          m = (comp_piece_val[VALUE_Q] - comp_piece_val[VALUE_P]);
      if( x > 0 )
      {
        to = sq + 8 - 1;  
        GET_CAP_PAWN;
      }
      if( x < 7 )
      {
        to = sq + 8 + 1;  
        GET_CAP_PAWN;
      }          
 
    }
    maxVal = m;
 }else{ // NOT PAWNS
      int n0,d,j,n1,u;
      int c1 = c^1;
      if ( SWEEP( p ) ) // ROOK & BISHOP & QUEEN
      {
        n0 = MAP( sq );
        for ( j = d_start[p]; j <= d_stop[p]; j++ )
        {
          d = dir[j];
          for ( n1 = n0 + d; ( n1 & 0x88 ) == 0; n1 += d )
          {
            u = UNMAP( n1 );
            if ( g.color[u] == NEUTRAL );
            else
            {
              if ( g.color[u] == c1 )
              {
                 int cap_p = g.pos[u];
                 maxVal = max(maxVal,comp_piece_val[cap_p]); 
              }
              break;
            }
          }
        }
      }
      else // KNIGHT & KING
      {
         U64 a;
         if( p == KING ) a = kingAttack[sq];
         else a = knightAttack[sq];

         for(a &= g.all[c1]  ; a; a &= a - 1)
         {
           int u = GetFirst(a);
              if ( g.color[u] == c1 )
              {
                 int cap_p = g.pos[u];
                 maxVal = max(maxVal,comp_piece_val[cap_p]); 
              }
         }

      } 
 
 }//endif
  return maxVal;
}


 
