/* 
   @author Korniloff E.
     2007
*/

#ifdef _WINDOWS_
#include <windows.h>
#define TICK_COUNT  (GetTickCount()/10)
#else
#define TICK_COUNT  (time(0)*100)
#endif

#include  "chess.h"
#include "learn.h"




time_t start_time,curr_time,limit_time = 7.5*100,ext_time;
int is_stop_search; 
int search_result;
int search_depth;
int is_get_ext_time;
U64 cnt_nodes;

struct{
  int depth,score;
}s_result[2];


void insert_search_result(int score, int depth ){

	if( s_result[0].depth==depth )
	{
	  s_result[0].score = score;
	}else{
      s_result[1] = s_result[0];

	  s_result[0].depth = depth;
	  s_result[0].score = score;

	}
}

int last_move_is_good(void){
  return  ( s_result[0].depth > 6)
		      &&
		   //abs(s_result[0]-s_result[1]) < 30 ;
		   ( s_result[0].score  >= s_result[1].score - 30 );
}

void TimeReset(void){
  start_time = curr_time = TICK_COUNT;
  cnt_nodes = 0;
  is_stop_search = 0;
  
  search_result = 0;
  search_depth = 0;
  is_get_ext_time = 0;

  s_result[0].score = -INF;
  s_result[0].depth = 0;
  s_result[1].score = -INF;
  s_result[1].depth = 0;
}

int StopSearch(void){
   

   if( (++cnt_nodes & 0xFFF)==0  &&  !is_stop_search)
   {
	  
      curr_time = TICK_COUNT;
      if(curr_time < start_time) start_time = curr_time;
	 

	  if(curr_time - start_time > limit_time){
	     if( !is_get_ext_time && !last_move_is_good()) 
		 {
		    limit_time += ext_time;
		    is_get_ext_time = 1;
			/////
			//printf("#-----> get extra time  \n");
		 }
		 if(curr_time - start_time > limit_time)
		   is_stop_search = 1;
	  }
   }
   return is_stop_search;
}
